#!/usr/bin/env python
# coding: utf-8

# ### 背景
# 班级现有一笔经费1000元，经讨论后选择购买单价分别为1.8元的笔记本、1.9元的笔、2.1元的小饰品作为活动奖励和纪念品，每一种物品至少买100件，并且要尽可能的用完经费。</br>
# 如何设计才能实现购买商品数量最多？当数量相同的情况下余额最少则为最佳方案，计算最佳方案下，每一种物品的数量是多少，余额是多少？
# ### 要求
# 使用循环嵌套的方法变成解决以上最优采购问题。

# ### 思路
# 假设购买笔记本、笔、小饰品数量分别为x,y,z，所剩余额为r元，所买物品总数量为s件，根据题意可以得到关系式：1.8x+1.9y+2.1z≤1000.</br>
# 1）令x1=100,y1=100,z1=100,s=300,则r=1000-(10\*1.8+100\*1.9+100\*2.1);</br>
# 2）如果只买1.8元笔记本可以买555个，只买1.9元笔可以买526个，只买饰品可以买476个.将对应的z,y,z从100到对应的555，526，476进行穷举;</br>
# 3）如果1.8x+1.9y+2.1z≤1000，若x+y+z>s，则s=x+y+z，r=1000-(1.8x+1.9y+2.1z),x1=1,y1=y,z1=z;</br>
# 4) 若x+y+z=s，且1000-(1.8x+1.9y+2.1z)<r,则r=1000-(1.8x+1.9y+2.1z),x1=1,y1=y,z1=z;</br>

# In[17]:


# 假设物品各买100个，所买物品为300个，余额为1000-(100*1.8+100*1.9+100*2.1)
x1=100   # 初始x为100
y1=100   # 初始y为100
z1=100   # 初始z为100
s=300    # 所买物品300个
r=1000-(100*1.8+100*1.9+100*2.1)  # 所剩余额
for x in range(100,556):    # 对x进行穷举
    for y in range(100,527):    # 对y进行穷举
        for z in range(476):    # 对z进行穷举
            if 1.8*x + 1.9*y + 2.1*z <=1000:
                if x+y+z >s:
                    s=x+y+z
                    r=1000-(1.8*x+1.9*y+2.1*z)
                    x1=x
                    y1=y
                    z1=z
                   
                if x+y+z==s and r >= 1000-(1.8*x + 1.9*y + 2.1*z):
                    s=x+y+z
                    r=1000-(1.8*x + 1.9*y + 2.1*z)
                    x1=x
                    y1=y
                    z1=z
            else:
                break

print("符合条件的最优方案是：")
print("购买单价1.8元的笔记本数量是：", x1)
print("购买单价1.9元的笔数量是：", y1)
print("购买单价2.1元的饰品数量是：", z1)
print("共购买物品数量是：", s)
print("所剩余额是：", r)


# In[1]:


# 假设物品各买100个，所买物品为300个，余额为1000-(100*1.8+100*1.9+100*2.1)
x1=100   # 初始x为100
y1=100   # 初始y为100
z1=100   # 初始z为100
s=300    # 所买物品300个
r=1000-(100*1.8+100*1.9+100*2.1)  # 所剩余额
for x in range(100,556):    # 对x进行穷举
    for y in range(100,527):    # 对y进行穷举
        for z in range(100,477):    # 对z进行穷举
            if 1.8*x + 1.9*y + 2.1*z <=1000:
                if x+y+z >s:
                    s=x+y+z
                    r=1000-(1.8*x + 1.9*y + 2.1*z)
                    x1=x
                    y1=y
                    z1=z
                if x+y+z==s and r >= 1000-(1.8*x + 1.9*y + 2.1*z):
                    s=x+y+z
                    r=1000-(1.8*x + 1.9*y + 2.1*z)
                    x1=x
                    y1=y
                    z1=z
            else:
                break

print("符合条件的最优方案是：")
print("购买单价1.8元的笔记本数量是：", x1)
print("购买单价1.9元的笔数量是：", y1)
print("购买单价2.1元的饰品数量是：", z1)
print("共购买物品数量是：", s)
print("所剩余额是：", r)


# In[ ]:




